#include <iSL.mqh>
#property indicator_separate_window

#property indicator_color1 Yellow
//#property indicator_color2 Green

#property indicator_buffers 1
#property indicator_maximum 1

#property indicator_minimum 0


extern int TPB=50;
extern int TPS=50;

extern int T=14400;
extern bool S=false;
extern bool C=true; 

double a0[];
//double a1[];

int h=0;
double rates[][6];


int init()
{
   string s=WindowExpertName() + "(B:"+TPB+",S:"+TPS+",T:"+T+")" ;
   IndicatorShortName( s );
   
   SetIndexStyle  ( 0, DRAW_HISTOGRAM );// DRAW_SECTION
   SetIndexBuffer ( 0, a0 );
   SetIndexEmptyValue ( 0, EMPTY_VALUE );
   SetIndexLabel(0,s);
   
   for(int i=0;i<10;i++)
      SetLevelValue(i,0.1*i);
      
  /* 
   ObjectCreate("o1",OBJ_HLINE,1, 0, 0.5); 
   ObjectSet("o1",OBJPROP_COLOR,Red);
   ObjectSet("o1",OBJPROP_BACK,false);
   ObjectCreate("o2",OBJ_HLINE,1, 0, 0.7);
   ObjectSet("o2",OBJPROP_COLOR,Red);
   ObjectSet("o2",OBJPROP_BACK,false);*/
/*   
   SetIndexStyle  ( 1, DRAW_LINE );
   SetIndexBuffer ( 1, a1 );
   SetIndexEmptyValue ( 1, EMPTY_VALUE );
  */
  
   T=T/Period();
  
   
   
   ArrayCopyRates(rates);
   
   h=iSLInit ( rates, Bars , Point, MarketInfo(Symbol(), MODE_MINLOT) );
  
   return(0);
}

int deinit()
{
  iSLDeInit(h);
  return(0);
}

int start()
{
 
   ObjectCreate("o1",OBJ_HLINE,1, 0, 0.5); 
   ObjectSet("o1",OBJPROP_COLOR,Red);
   ObjectSet("o1",OBJPROP_BACK,false);
   ObjectCreate("o2",OBJ_HLINE,1, 0, 0.7);
   ObjectSet("o2",OBJPROP_COLOR,Red);
   ObjectSet("o2",OBJPROP_BACK,false);
   int s,e;
   if ( C ){
   
      s=WindowFirstVisibleBar();
   
      e=s-WindowBarsPerChart();
   }
   else {
      s=Bars-T;
      e=0;
   }
   bool cr;
   
   for ( int i=s;i>=e;i--){
      if ( a0[i] != EMPTY_VALUE )
         continue;
      
      if ( ! cr ){
         cr=true;
         ArrayCopyRates(rates);
         iSLStart ( h, rates, Bars );
      }   
      
      if ( S )
         a0[i]= iSLPSell  ( h, TPB, TPS,  i+T,i);
      else
         a0[i]= iSLPBuy   ( h, TPB, TPS , i+T,i);
     
   }
      
}

